package cz.muni.fi.pb162.abstractclasses;

// Slovo "Abstract" v názve triedy nie je nutné, bolo požité len na rozlíšenie od rozhrania Animal
public abstract class AbstractAnimal implements Animal {
    // abstraktná trieda môže mať svoje atribúty
    private double height;
    private double weight;

    // môže mať aj konštruktor, ktorý napríklad napĺňa atribúty určitými hodnotami
    // nie je možné ju inštanciovať samostatné => new AbstractAnimal(1.7, 100) vyhodi výnimku pri kompilácii
    public AbstractAnimal(final double height, final double weight) {
        this.height = height;
        this.weight = weight;
    }

    public double getHeight() {
        return height;
    }

    public double getWeight() {
        return weight;
    }

    // základnú implementáciu je možné prepísať v podtriede
    public String getResource() {
        return "Friendship";
    }

    // abstraktné metódy sú označené kľúčovým slovom abstract
    // každá trieda ktorá rozširuje túto triedu bude musieť implementovať túto metódu
    public abstract String makeNoise();
}
