package cz.muni.fi.pb162.equalsandhashcode;

/**
 * Porovnanie objektov pomocou operátoru == porovnáva adresy, na ktoré ukazujú jednotlivé odkazy
 * Ak chceme porovnať rovnosť obsahu jednotlivých objektov využíjeme metódu equals
 * Táto metóda sa nachádza v každej triede, avšak funguje rovnako ako operátor ==
 * Ak chceme aby porovnávala rovnosť obsahu, je nutné ju prepísať (Override)
 * Názornú ukážku nájdete v triede Person
 */
public class Demo {

    public static void main(String[] args) {
        Person peter = new Person("Peter", 1980);
        Person samePeter = peter;
        Person secondPeter = new Person("Peter", 1980);

        // Odkazy peter a samePeter odkazuju na rovnaký objekt (adresu)
        // Porovnaním týchto dvoch odkazov pomocou operátoru == získame hodnotu true
        System.out.println("peter == samePeter: " + (peter == samePeter)); // true

        // Odkazy peter a secondPeter odkazujú na rôzne objekty, ktoré však majú rovnaké hodnoty atribútov
        // Porovnanie týchto dvoch odkazov pomocou operátoru == vráti hodnotu false
        System.out.println("peter == secondPeter: " + (peter == secondPeter));

        // ak však odkazy peter a secondPeter porovnáme metódou equals, táto metóda vráti hodnotu true
        System.out.println("peter.equals(secondPeter): " + peter.equals(secondPeter));
    }
}
