package cz.muni.fi.pb162.equalsandhashcode;

/**
 * Metódy equals a hashcode je možné vygenerovať => right click => Generate.. => equals() and hashCode()
 * Týmto metódam je nutné rozumieť. V tejto triede nájdete ukážku manuálne vytvorenej metódy equals a hashCode
 */
public class Person {
    private String name;
    private int yearOfBirth;
    private double salary;

    public Person(String name, int yearOfBirth) {
        this.name = name;
        this.yearOfBirth = yearOfBirth;
    }

    public String getName() {
        return name;
    }

    public int getYearOfBirth() {
        return yearOfBirth;
    }

    @Override
    public boolean equals(Object obj) {
        // overenie, že objekt, ktorý porovnávame, nie je null
        if (obj == null) {
            return false;
        }
        // overenie, že objekt, ktorý porovnávam je inštanciou tejto triedy
        if (obj.getClass() != this.getClass()) {
            return false;
        }
        // pretypovanie objektu na typ Person
        Person otherPerson = (Person) obj;
        // porovnanie jedlivých atribútov triedy
        return this.getYearOfBirth() == otherPerson.getYearOfBirth()
                && this.getName().equals(otherPerson.getName());
    }

    // ak prekrývame metódu equals je nutné prekryť aj metódu hashCode()
    // metóda vráti hash objektu
    // hashCode() na rovnakom objekte MUSÍ vždy vrátiť rovnakú hodnotu
    // pre rôzne objekty by mal vrátiť rôznu hodnotu (nie je nutné)
    // nesprávne vytvorený (opomenutý) hashCode môže spôsobiť problémy v niektorých dátových štruktúrach
    @Override
    public int hashCode() {
        int hash = name.hashCode();
        hash += 31 * hash + yearOfBirth;
        return hash;
    }
}